/**
 *	@file	OsVersion.h
 *	@brief	Win OS ̃o[W (ł IE)
 *	@author	+mod
 *	@note
 *	-	unDonut(DonutP) OS擾֌WQlɍ쐬.
 */
#ifndef OSVERSION_H
#define OSVERSION_H

#include "patriotGlobal2.h"

#define USE_OSVERSION_WIN9X		// Win98 ֌W`FbNꍇ͒`.


/// OS ̃o[W擾.
class COsVersion {
public:
	enum EOs {
		OS_UNKOWN_OLD,
	  #ifdef USE_OSVERSION_WIN9X
		OS_W98,
		OS_W98SE,
		OS_WINME,
		OS_NT4,
	  #endif
		OS_W2K,
		OS_XP,
		OS_SERVER2003,	// or Xp64?
		OS_VISTA,
		OS_WIN7,

		OS_UNKOWN_NEW,
	};

	COsVersion();

	// wb_ɒu߂InstanceɎ̂uĂ邪 staticôقf낤...
	static COsVersion& Instance()		{ static COsVersion instance; return instance; }

	static const OSVERSIONINFO& Info()	{ return Instance().m_versionInfo; }
	static unsigned MajorVersion()		{ return Instance().m_versionInfo.dwMajorVersion; }
	static unsigned MinorVersion()		{ return Instance().m_versionInfo.dwMinorVersion; }
	static unsigned PlatformId()		{ return Instance().m_versionInfo.dwPlatformId;	 }

  #ifdef _WIN64
	static bool		IsWin64()			{ return 1; }
  #else
	static bool		IsWin64()			{ return Instance().m_isWin64; }
  #endif
	static EOs		OsType()			{ return Instance().m_osType; }
	static unsigned	SpNo()				{ return Instance().m_servicePackNo; }

	static bool		IsPlatformNT()		{ return PlatformId() == VER_PLATFORM_WIN32_NT; }	// NTn?

	static bool		IsW2k_Later()		{ return Instance().m_osType >= OS_W2K; }
	static bool		IsW2kSp4_Later()	{ return IsXp_Later() || (IsW2k_Later() && SpNo() >= 4); }
	static bool		IsXp_Later()		{ return Instance().m_osType >= OS_XP; }
	static bool		IsXpSp1_Later() 	{ return IsVista_Later() || (IsXp_Later() && SpNo() >= 1); }
	static bool		IsXpSp2_Later() 	{ return IsVista_Later() || (IsXp_Later() && SpNo() >= 2); }
	static bool		IsXpSp3_Later() 	{ return IsVista_Later() || (IsXp_Later() && SpNo() >= 3); }
	static bool		IsVista_Later() 	{ return Instance().m_osType >= OS_VISTA; }
	static bool		IsVistaSp1_Later()	{ return IsWin7_Later() || (IsVista_Later() && SpNo() >= 1); }
	static bool		IsVistaSp2_Later()	{ return IsWin7_Later() || (IsVista_Later() && SpNo() >= 2); }
	static bool		IsWin7_Later()		{ return Instance().m_osType >= OS_WIN7; }

	static const TCHAR*	  OsName()		{ return Instance().m_pOsName; }
	static const TCHAR*	  CSDVersion()	{ return Instance().m_versionInfo.szCSDVersion;	 }
	static const CString& VersionStr()	{ return Instance().m_versionStr; }

	static float		  IEVersion()  	{ return Instance().m_ieVersion; }
	static const CString& IEVersionStr(){ return Instance().m_ieVersionStr; }
	static const CString& IEUpdateInfo(){ return Instance().m_ieUpdateInfo; }

private:
	bool 				isWow64();
	EOs					getOsType();
	const TCHAR*		getOsName();
	CString 			getVersionStr();
	CString 			getIeUpdateInfo();
	CString				getIEVersionStr();

private:
	OSVERSIONINFO		m_versionInfo;

	// fobȌɂȂ邩AŁA킴ƃo[ϐɓɂĂ.
	bool				m_isWin64;
	EOs					m_osType;
	unsigned			m_servicePackNo;
	float				m_ieVersion;

	const TCHAR*		m_pOsName;
	CString				m_versionStr;

	CString				m_ieUpdateInfo;
	CString				m_ieVersionStr;

  #if !(defined NDEBUG) && _MSC_VER >= 1300 // VC7ȏł̃fobO.
	static COsVersion*	m_pInstance;
  #endif
};


#if !(defined NDEBUG) && _MSC_VER >= 1300 // VC7ȏł̃fobO.
__declspec(selectany) COsVersion*	COsVersion::m_pInstance;
#endif


/// .
inline COsVersion::COsVersion() {
	ASSERT( this == &Instance() );
  #if !(defined NDEBUG) && _MSC_VER >= 1300 // VC7ȏł̃fobO.
	m_pInstance = this;
  #endif

	// Wow64(Win64ł32rbg[h)œĂ邩ǂ
  #ifdef _WIN64
	m_isWin64 = 1;
  #else
	m_isWin64 = isWow64();
  #endif

	// OS擾.
	ZeroMemory(&m_versionInfo, sizeof m_versionInfo);
	m_versionInfo.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	::GetVersionEx( &m_versionInfo );

	m_osType		= getOsType();

	// T[rXpbN̊mF.
	m_servicePackNo 	= 0;
	if (_tcsnicmp(m_versionInfo.szCSDVersion, _T("Service Pack"), 12) == 0) {
		m_servicePackNo = _tcstoul(&m_versionInfo.szCSDVersion[12], NULL, 10);
	}

	m_pOsName	   = getOsName();			// OS 
	m_versionStr   = getVersionStr();		// o[Wԍ
	m_ieUpdateInfo = getIeUpdateInfo();		// osM
	m_ieVersionStr = getIEVersionStr();		// ie version 
	m_ieVersion    = float(_tcstod(LPCTSTR(m_ieVersionStr),NULL));	// IE Version.
}


/// o[W`FbN (Windows Ver.4͖)
inline COsVersion::EOs	COsVersion::getOsType() {
	EOs	osType	 = OS_UNKOWN_OLD;
   #ifdef USE_OSVERSION_WIN9X	// 98܂߂ꍇ.
	if (m_versionInfo.dwMajorVersion == 4) {
		osType	 = OS_UNKOWN_OLD/*OS_W95*/;
		if (m_versionInfo.dwPlatformId == VER_PLATFORM_WIN32_WINDOWS) {
			if (m_versionInfo.dwMinorVersion >= 10) {
				osType	 	= OS_W98;
				if (m_versionInfo.szCSDVersion[1] == 'A')
					osType	= OS_W98SE;
			}
			if (m_versionInfo.dwMinorVersion >= 90)
				osType	= OS_WINME;
		} else {	// NTn
			osType	= OS_NT4;
		}
	} else
   #endif
	if (m_versionInfo.dwMajorVersion == 5) {
		osType = OS_W2K;
		if (m_versionInfo.dwMinorVersion >= 1)
			osType = OS_XP;
		if (m_versionInfo.dwMinorVersion >= 2)
			osType = OS_SERVER2003;
	} else if (m_versionInfo.dwMajorVersion == 6) {
		osType = OS_VISTA;
		if (m_versionInfo.dwMinorVersion >= 1)
			osType = OS_WIN7;
	} else if (m_versionInfo.dwMajorVersion > 6) {
		osType = OS_UNKOWN_NEW;
	}
	return osType;
}


/// wow64 ?
inline bool COsVersion::isWow64() {
  #if defined _WIN64
	return 1;
  #else
	typedef BOOL (WINAPI   * LPFN_ISWOW64PROCESS)(HANDLE, PBOOL);
	BOOL				bIsWow64		 = FALSE;
	LPFN_ISWOW64PROCESS fnIsWow64Process = (LPFN_ISWOW64PROCESS)::GetProcAddress(GetModuleHandle( TEXT("kernel32") ), "IsWow64Process");
	if (fnIsWow64Process) {
		if ( !fnIsWow64Process(::GetCurrentProcess(), &bIsWow64) ) {
			;	// handle error
		}
	}
	return bIsWow64 != 0;
  #endif
}


/// OS .
inline const TCHAR*	COsVersion::getOsName() {
	static const TCHAR*	s_names[][OS_UNKOWN_NEW+1] = {
	  #if defined _WIN64 == 0
		{
			_T("[UNKOWN(old)]"),
		  #ifdef USE_OSVERSION_WIN9X
			_T("Windows 98"),
			_T("Windows 98SE"),
			_T("Windows Me"),
			_T("Windows NT 4.0"),
		  #endif
			_T("Windows 2000"),
			_T("Windows Xp"),
			_T("Windows Server 2003"),
			_T("Windows Vista"),
			_T("Windows 7"),
			_T("[UNKOWN(new)]"),
		},
	  #endif
		{
			_T("[UNKOWN(old)]"),
		  #ifdef USE_OSVERSION_WIN9X
			_T("[UNKOWN(w98)]"),
			_T("[UNKOWN(w98se)]"),
			_T("[UNKOWN(me)]"),
			_T("[UNKOWN(nt4)]"),
		  #endif
			_T("Windows 2000(x64)"),
			_T("Windows Xp(x64)"),			// Ȃ
			_T("Windows Server 2003(x64)"),	// Xp64͂Ɠ?
			_T("Windows Vista(x64)"),
			_T("Windows 7(x64)"),
			_T("[UNKOWN(new)]"),
		}
	};

	if (m_osType > OS_UNKOWN_NEW)
		m_osType = OS_UNKOWN_NEW;
  #if defined _WIN64 == 0
	return s_names[ m_isWin64 != 0 ][ m_osType ];
  #else
	return s_names[ 0 ][ m_osType ];
  #endif
}


/// OSo[W̕擾.
inline CString COsVersion::getVersionStr()
{
	CString buf;
	buf.Format( _T("%d.%d.%d")
			  , m_versionInfo.dwMajorVersion
			  , m_versionInfo.dwMinorVersion
			  , (unsigned short) m_versionInfo.dwBuildNumber
			  );
	return buf;
}


/// IE @[W
inline CString COsVersion::getIEVersionStr()
{
	//	GetRegStr  bura  ֐.
	CString s  = ::GetRegStr( HKEY_LOCAL_MACHINE
							, _T("Software\\Microsoft\\Internet Explorer")
							, _T("Version")
			  				, _T("") );
	if (s.IsEmpty()) {
		s	   = ::GetRegStr( HKEY_LOCAL_MACHINE
							, _T("Software\\Microsoft\\Internet Explorer\\Version Vector")
							, _T("IE")
			  				, _T("") );
	}
	return s;
}


/// IE?̃@[WAbv.
inline CString COsVersion::getIeUpdateInfo()
{
	//	GetRegStr  bura  ֐.
	return	 ::GetRegStr( HKEY_LOCAL_MACHINE
						, _T("Software\\Microsoft\\Windows\\CurrentVersion\\Internet Settings")
						, _T("MinorVersion")
		  				, _T("") );
}


#endif	// OSVERSION_H
